--- JoglPipelineOLD.java	2016-11-07 16:27:54.000000000 +0100
+++ JoglPipeline.java	2017-12-28 22:54:49.000000000 +0100
@@ -6737,7 +6953,7 @@
                     type = GL2.GL_BGRA;
                     intType = GL2.GL_UNSIGNED_INT_8_8_8_8_REV;
                     break;
-                    /* This method only supports 3 and 4 components formats and BYTE types. */
+                /* This method only supports 3 and 4 components formats and BYTE types. */
                 case ImageComponentRetained.TYPE_BYTE_LA:
                 case ImageComponentRetained.TYPE_BYTE_GRAY:
                 case ImageComponentRetained.TYPE_USHORT_GRAY:
@@ -6750,46 +6966,45 @@
             }
 
             /* Force Alpha to 1.0 if needed */
-            if(forceAlphaToOne) {
+            if (forceAlphaToOne) {
                 gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 0.0f);
                 gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 1.0f);
             }
 
             gl.glReadPixels(0, 0, width, height, type, intType, IntBuffer.wrap((int[]) data));
 
-	    /* Restore Alpha scale and bias */
-	    if(forceAlphaToOne) {
-		gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 1.0f);
-		gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 0.0f);
-	    }
-        }
-        else {
+            /* Restore Alpha scale and bias */
+            if (forceAlphaToOne) {
+                gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 1.0f);
+                gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 0.0f);
+            }
+        } else {
             throw new AssertionError("illegal image data type " + dataType);
         }
 
         // If FBO
         if (chosenCaps.isFBO()) {
-        	// bind FBO for drawing
-        	fboDrawable.getFBObject( GL.GL_BACK ).bind(gl);
+            // bind FBO for drawing
+            fboDrawable.getFBObject(GL.GL_BACK).bind(gl);
         }
     }
 
-	// The native method for swapBuffers - onscreen only
-@Override
-void swapBuffers(Canvas3D cv, Context ctx, Drawable drawable) {
-	if (VERBOSE) System.err.println("JoglPipeline.swapBuffers()");
-	GLDrawable draw = drawable(drawable);
-	draw.swapBuffers();
-}
+    // The native method for swapBuffers - onscreen only
+    @Override
+    void swapBuffers(Canvas3D cv, Context ctx, Drawable drawable) {
+        if (VERBOSE) System.err.println("JoglPipeline.swapBuffers()");
+        GLDrawable draw = drawable(drawable);
+        draw.swapBuffers();
+    }
 
     // native method for setting Material when no material is present
     @Override
     void updateMaterialColor(Context ctx, float r, float g, float b, float a) {
         if (VERBOSE) System.err.println("JoglPipeline.updateMaterialColor()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
-		// FIXME: Removed call to glColor4f because of segfault issues in Parallels Desktop driver
-		// gl.glColor4f(r, g, b, a);
+        GL2 gl = context(ctx).getGL().getGL2();
+        // FIXME: Removed call to glColor4f because of segfault issues in Parallels Desktop driver
+        // gl.glColor4f(r, g, b, a);
         gl.glDisable(GL2.GL_LIGHTING);
     }
 
@@ -6797,13 +7012,13 @@
     void destroyContext(Drawable drawable, Context ctx) {
         if (VERBOSE) System.err.println("JoglPipeline.destroyContext()");
 
-        JoglDrawable joglDrawable =	(JoglDrawable)drawable;
-        GLContext  context  = context(ctx);
+        JoglDrawable joglDrawable = (JoglDrawable) drawable;
+        GLContext context = context(ctx);
 
         if (GLContext.getCurrent() == context) {
             context.release();
         }
-        context.destroy();
+        //context.destroy();
 
         // assuming this is the right point at which to make this call
         joglDrawable.getGLDrawable().setRealized(false);
@@ -6816,7 +7031,7 @@
     void accum(Context ctx, float value) {
         if (VERBOSE) System.err.println("JoglPipeline.accum()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glReadBuffer(GL.GL_BACK);
         gl.glAccum(GL2.GL_ACCUM, value);
         gl.glReadBuffer(GL.GL_FRONT);
@@ -6827,7 +7042,7 @@
     void accumReturn(Context ctx) {
         if (VERBOSE) System.err.println("JoglPipeline.accumReturn()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glAccum(GL2.GL_RETURN, 1.0f);
     }
 
@@ -6896,7 +7111,7 @@
     void ctxUpdateEyeLightingEnable(Context ctx, boolean localEyeLightingEnable) {
         if (VERBOSE) System.err.println("JoglPipeline.ctxUpdateEyeLightingEnable()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         if (localEyeLightingEnable) {
             gl.glLightModeli(GL2.GL_LIGHT_MODEL_LOCAL_VIEWER, GL.GL_TRUE);
@@ -6905,15 +7120,13 @@
         }
     }
 
-    // The following three methods are used in multi-pass case
-
     // native method for setting blend color
     @Override
     void setBlendColor(Context ctx, float red, float green,
-            float blue, float alpha) {
+                       float blue, float alpha) {
         if (VERBOSE) System.err.println("JoglPipeline.setBlendColor()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         if (gl.isExtensionAvailable("GL_ARB_imaging")) {
             gl.glBlendColor(red, green, blue, alpha);
         }
@@ -6964,7 +7177,7 @@
     void updateSeparateSpecularColorEnable(Context ctx, boolean enable) {
         if (VERBOSE) System.err.println("JoglPipeline.updateSeparateSpecularColorEnable()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         if (enable) {
             gl.glLightModeli(GL2.GL_LIGHT_MODEL_COLOR_CONTROL, GL2.GL_SEPARATE_SPECULAR_COLOR);
@@ -7015,7 +7228,7 @@
     void setSceneAmbient(Context ctx, float red, float green, float blue) {
         if (VERBOSE) System.err.println("JoglPipeline.setSceneAmbient()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         float[] color = new float[4];
         color[0] = red;
@@ -7052,11 +7265,11 @@
     // native method for setting default RenderingAttributes
     @Override
     void resetRenderingAttributes(Context ctx,
-            boolean depthBufferWriteEnableOverride,
-            boolean depthBufferEnableOverride) {
+                                  boolean depthBufferWriteEnableOverride,
+                                  boolean depthBufferEnableOverride) {
         if (VERBOSE) System.err.println("JoglPipeline.resetRenderingAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         if (!depthBufferWriteEnableOverride) {
             gl.glDepthMask(true);
@@ -7069,7 +7282,7 @@
         gl.glEnable(GL2.GL_COLOR_MATERIAL);
         gl.glDisable(GL.GL_COLOR_LOGIC_OP);
         gl.glDisable(GL.GL_STENCIL_TEST);
-       
+
     }
 
     // native method for setting default texture
@@ -7077,7 +7290,7 @@
     void resetTextureNative(Context ctx, int texUnitIndex) {
         if (VERBOSE) System.err.println("JoglPipeline.resetTextureNative()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         if (texUnitIndex >= 0 &&
                 gl.isExtensionAvailable("GL_VERSION_1_3")) {
             gl.glActiveTexture(texUnitIndex + GL.GL_TEXTURE0);
@@ -7095,7 +7308,7 @@
     void activeTextureUnit(Context ctx, int texUnitIndex) {
         if (VERBOSE) System.err.println("JoglPipeline.activeTextureUnit()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         if (gl.isExtensionAvailable("GL_VERSION_1_3")) {
             gl.glActiveTexture(texUnitIndex + GL.GL_TEXTURE0);
             gl.glClientActiveTexture(texUnitIndex + GL.GL_TEXTURE0);
@@ -7114,12 +7327,16 @@
         gl.glDisable(GL2.GL_TEXTURE_GEN_Q);
     }
 
+    //----------------------------------------------------------------------
+    // Helper private functions for Canvas3D
+    //
+
     // native method for setting default TextureAttributes
     @Override
     void resetTextureAttributes(Context ctx) {
         if (VERBOSE) System.err.println("JoglPipeline.resetTextureAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         float[] color = new float[4];
 
@@ -7147,7 +7364,7 @@
     void resetPolygonAttributes(Context ctx) {
         if (VERBOSE) System.err.println("JoglPipeline.resetPolygonAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         gl.glCullFace(GL.GL_BACK);
         gl.glEnable(GL.GL_CULL_FACE);
@@ -7162,6 +7379,20 @@
         gl.glDisable(GL.GL_POLYGON_OFFSET_FILL);
     }
 
+// FIXME: GL_SGI_texture_color_table
+//    private int getTextureColorTableSize(GL gl) {
+//        if (!gl.isExtensionAvailable("GL_ARB_imaging")) {
+//            return 0;
+//        }
+//
+//        gl.glColorTable(GL.GL_PROXY_TEXTURE_COLOR_TABLE_SGI, GL.GL_RGBA, 256, GL.GL_RGB,
+//                GL2.GL_INT, null);
+//        int[] tmp = new int[1];
+//        gl.glGetColorTableParameteriv(GL.GL_PROXY_TEXTURE_COLOR_TABLE_SGI,
+//                GL2.GL_COLOR_TABLE_WIDTH, tmp, 0);
+//        return tmp[0];
+//    }
+
     // native method for setting default LineAttributes
     @Override
     void resetLineAttributes(Context ctx) {
@@ -7180,7 +7411,7 @@
     void resetPointAttributes(Context ctx) {
         if (VERBOSE) System.err.println("JoglPipeline.resetPointAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glPointSize(1.0f);
 
         // XXXX: Polygon Mode check, blend enable
@@ -7190,8 +7421,8 @@
     // native method for setting default TransparencyAttributes
     @Override
     void resetTransparency(Context ctx, int geometryType,
-            int polygonMode, boolean lineAA,
-            boolean pointAA) {
+                           int polygonMode, boolean lineAA,
+                           boolean pointAA) {
         if (VERBOSE) System.err.println("JoglPipeline.resetTransparency()");
 
         GL gl = context(ctx).getGL();
@@ -7200,8 +7431,8 @@
                 (polygonMode == PolygonAttributes.POLYGON_LINE))
                 && lineAA) ||
                 ((((geometryType & RenderMolecule.POINT) != 0) ||
-                (polygonMode == PolygonAttributes.POLYGON_POINT))
-                && pointAA)) {
+                        (polygonMode == PolygonAttributes.POLYGON_POINT))
+                        && pointAA)) {
             gl.glEnable(GL.GL_BLEND);
             gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);
         } else {
@@ -7213,23 +7444,23 @@
     // native method for setting default ColoringAttributes
     @Override
     void resetColoringAttributes(Context ctx,
-            float r, float g,
-            float b, float a,
-            boolean enableLight) {
+                                 float r, float g,
+                                 float b, float a,
+                                 boolean enableLight) {
         if (VERBOSE) System.err.println("JoglPipeline.resetColoringAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
-		if (!enableLight) {
-			// FIXME: Removed call to glColor4f because of segfault issues in Parallels Desktop driver
-			// gl.glColor4f(r, g, b, a);
-		}
+        if (!enableLight) {
+            // FIXME: Removed call to glColor4f because of segfault issues in Parallels Desktop driver
+            // gl.glColor4f(r, g, b, a);
+        }
         gl.glShadeModel(GL2.GL_SMOOTH);
     }
 
     /**
-     *  This native method makes sure that the rendering for this canvas
-     *  gets done now.
+     * This native method makes sure that the rendering for this canvas
+     * gets done now.
      */
     @Override
     void syncRender(Context ctx, boolean wait) {
@@ -7252,6 +7483,13 @@
         return (res != GLContext.CONTEXT_NOT_CURRENT);
     }
 
+    // ---------------------------------------------------------------------
+
+    //
+    // Canvas3D / GraphicsConfigTemplate3D methods - logic dealing with
+    // native graphics configuration or drawing surface
+    //
+
     // Optionally release the context. Returns true if the context was released.
     @Override
     boolean releaseCtx(Context ctx) {
@@ -7267,7 +7505,7 @@
 
         JoglContext jctx = (JoglContext) ctx;
         GLContext context = context(ctx);
-		GL2 gl = context.getGL().getGL2();
+        GL2 gl = context.getGL().getGL2();
 
         // OBSOLETE CLEAR CODE
         /*
@@ -7313,11 +7551,11 @@
 
     @Override
     void textureFillBackground(Context ctx, float texMinU, float texMaxU, float texMinV, float texMaxV,
-            float mapMinX, float mapMaxX, float mapMinY, float mapMaxY, boolean useBilinearFilter)  {
+                               float mapMinX, float mapMaxX, float mapMinY, float mapMaxY, boolean useBilinearFilter) {
         if (VERBOSE) System.err.println("JoglPipeline.textureFillBackground()");
 
         GLContext context = context(ctx);
-		GL2 gl = context.getGL().getGL2();
+        GL2 gl = context.getGL().getGL2();
 
         // Temporarily disable fragment and most 3D operations
         gl.glPushAttrib(GL2.GL_ENABLE_BIT | GL2.GL_TEXTURE_BIT | GL2.GL_POLYGON_BIT);
@@ -7327,7 +7565,7 @@
         gl.glEnable(GL.GL_TEXTURE_2D);
 
         /* Setup filter mode if needed */
-        if(useBilinearFilter) {
+        if (useBilinearFilter) {
             // System.err.println("JoglPipeline - Background  : use bilinear filter\n");
             gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR);
             gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR);
@@ -7349,10 +7587,14 @@
         gl.glLoadIdentity();
 
         gl.glBegin(GL2.GL_QUADS);
-        gl.glTexCoord2f(texMinU, texMinV); gl.glVertex2f(mapMinX,mapMinY);
-        gl.glTexCoord2f(texMaxU, texMinV); gl.glVertex2f(mapMaxX,mapMinY);
-        gl.glTexCoord2f(texMaxU, texMaxV); gl.glVertex2f(mapMaxX,mapMaxY);
-        gl.glTexCoord2f(texMinU, texMaxV); gl.glVertex2f(mapMinX,mapMaxY);
+        gl.glTexCoord2f(texMinU, texMinV);
+        gl.glVertex2f(mapMinX, mapMinY);
+        gl.glTexCoord2f(texMaxU, texMinV);
+        gl.glVertex2f(mapMaxX, mapMinY);
+        gl.glTexCoord2f(texMaxU, texMaxV);
+        gl.glVertex2f(mapMaxX, mapMaxY);
+        gl.glTexCoord2f(texMinU, texMaxV);
+        gl.glVertex2f(mapMinX, mapMaxY);
         gl.glEnd();
 
         // Restore texture Matrix transform
@@ -7366,22 +7608,22 @@
 
     @Override
     void textureFillRaster(Context ctx, float texMinU, float texMaxU, float texMinV, float texMaxV,
-            float mapMinX, float mapMaxX, float mapMinY, float mapMaxY, float mapZ, float alpha,
-            boolean useBilinearFilter)  {
+                           float mapMinX, float mapMaxX, float mapMinY, float mapMaxY, float mapZ, float alpha,
+                           boolean useBilinearFilter) {
 
         if (VERBOSE) System.err.println("JoglPipeline.textureFillRaster()");
 
         GLContext context = context(ctx);
-		GL2 gl = context.getGL().getGL2();
+        GL2 gl = context.getGL().getGL2();
 
         // Temporarily disable fragment and most 3D operations
         gl.glPushAttrib(GL2.GL_ENABLE_BIT | GL2.GL_TEXTURE_BIT | GL2.GL_POLYGON_BIT |
-                GL2.GL_CURRENT_BIT );
+                GL2.GL_CURRENT_BIT);
 
         disableAttribForRaster(gl);
 
         /* Setup filter mode if needed */
-        if(useBilinearFilter) {
+        if (useBilinearFilter) {
             // System.err.println("JoglPipeline - Raster  : use bilinear filter\n");
             gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR);
             gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR);
@@ -7405,10 +7647,14 @@
         gl.glOrtho(0.0, 1.0, 0.0, 1.0, 0.0, 1.0);
 
         gl.glBegin(GL2.GL_QUADS);
-        gl.glTexCoord2f(texMinU, texMinV); gl.glVertex3f(mapMinX,mapMinY, mapZ);
-        gl.glTexCoord2f(texMaxU, texMinV); gl.glVertex3f(mapMaxX,mapMinY, mapZ);
-        gl.glTexCoord2f(texMaxU, texMaxV); gl.glVertex3f(mapMaxX,mapMaxY, mapZ);
-        gl.glTexCoord2f(texMinU, texMaxV); gl.glVertex3f(mapMinX,mapMaxY, mapZ);
+        gl.glTexCoord2f(texMinU, texMinV);
+        gl.glVertex3f(mapMinX, mapMinY, mapZ);
+        gl.glTexCoord2f(texMaxU, texMinV);
+        gl.glVertex3f(mapMaxX, mapMinY, mapZ);
+        gl.glTexCoord2f(texMaxU, texMaxV);
+        gl.glVertex3f(mapMaxX, mapMaxY, mapZ);
+        gl.glTexCoord2f(texMinU, texMaxV);
+        gl.glVertex3f(mapMinX, mapMaxY, mapZ);
         gl.glEnd();
 
         // Restore matrices
@@ -7422,11 +7668,11 @@
 
     @Override
     void executeRasterDepth(Context ctx, float posX, float posY, float posZ,
-            int srcOffsetX, int srcOffsetY, int rasterWidth, int rasterHeight,
-            int depthWidth, int depthHeight, int depthFormat, Object depthData) {
+                            int srcOffsetX, int srcOffsetY, int rasterWidth, int rasterHeight,
+                            int depthWidth, int depthHeight, int depthFormat, Object depthData) {
         if (VERBOSE) System.err.println("JoglPipeline.executeRasterDepth()");
         GLContext context = context(ctx);
-		GL2 gl = context.getGL().getGL2();
+        GL2 gl = context.getGL().getGL2();
 
 
         gl.glRasterPos3f(posX, posY, posZ);
@@ -7450,7 +7696,7 @@
         } else {
             rasterWidth += srcOffsetX;
             if (rasterWidth > depthWidth) {
-                rasterWidth  = depthWidth;
+                rasterWidth = depthWidth;
             }
         }
         if (srcOffsetY >= 0) {
@@ -7459,10 +7705,10 @@
                 rasterHeight = depthHeight - srcOffsetY;
             }
         } else {
-			rasterHeight += srcOffsetY;
-			if (rasterHeight > depthHeight) {
-				rasterHeight = depthHeight;
-			}
+            rasterHeight += srcOffsetY;
+            if (rasterHeight > depthHeight) {
+                rasterHeight = depthHeight;
+            }
         }
 
 
@@ -7488,7 +7734,7 @@
     void setModelViewMatrix(Context ctx, double[] viewMatrix, double[] modelMatrix) {
         if (VERBOSE) System.err.println("JoglPipeline.setModelViewMatrix()");
         GLContext context = context(ctx);
-		GL2 gl = context.getGL().getGL2();
+        GL2 gl = context.getGL().getGL2();
 
         gl.glMatrixMode(GL2.GL_MODELVIEW);
 
@@ -7510,7 +7756,7 @@
     void setProjectionMatrix(Context ctx, double[] projMatrix) {
         if (VERBOSE) System.err.println("JoglPipeline.setProjectionMatrix()");
         GLContext context = context(ctx);
-		GL2 gl = context.getGL().getGL2();
+        GL2 gl = context.getGL().getGL2();
 
         gl.glMatrixMode(GL2.GL_PROJECTION);
 
@@ -7541,30 +7787,6 @@
         }
     }
 
-static boolean isOffscreenLayerSurfaceEnabled(Canvas3D cv) {
-	if (cv.drawable == null || cv.offScreen)
-		return false;
-
-	JoglDrawable joglDrawble = (JoglDrawable)cv.drawable;
-	JAWTWindow jawtwindow = (JAWTWindow)joglDrawble.getNativeWindow();
-	if (jawtwindow == null)
-		return false;
-
-	return jawtwindow.isOffscreenLayerSurfaceEnabled();
-}
-
-static boolean hasFBObjectSizeChanged(JoglDrawable jdraw, int width, int height) {
-	if (!(jdraw.getGLDrawable() instanceof GLFBODrawable))
-		return false;
-
-	FBObject fboBack = ((GLFBODrawable)jdraw.getGLDrawable()).getFBObject(GL.GL_BACK);
-	if (fboBack == null)
-		return false;
-
-	return (width != fboBack.getWidth() || height != fboBack.getHeight());
-}
-
-
     // The native method for setting the Viewport.
     @Override
     void setViewport(Context ctx, int x, int y, int width, int height) {
@@ -7581,18 +7803,17 @@
             System.err.println("JAVA 3D ERROR : glNewList(" + displayListId + ") -- IGNORED");
         }
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glNewList(displayListId, GL2.GL_COMPILE);
     }
 
     @Override
     void endDisplayList(Context ctx) {
         if (VERBOSE) System.err.println("JoglPipeline.endDisplayList()");
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glEndList();
     }
 
-    int numInvalidLists = 0;
     @Override
     void callDisplayList(Context ctx, int id, boolean isNonUniformScale) {
         if (VERBOSE) System.err.println("JoglPipeline.callDisplayList()");
@@ -7607,7 +7828,7 @@
             return;
         }
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         // Set normalization if non-uniform scale
         if (isNonUniformScale) {
             gl.glEnable(GL2.GL_NORMALIZE);
@@ -7628,10 +7849,14 @@
             System.err.println("JAVA 3D ERROR : glDeleteLists(" + id + ",1) -- IGNORED");
         }
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glDeleteLists(id, 1);
     }
 
+    //----------------------------------------------------------------------
+    // Helper classes and methods to support query context functionality
+    // and pixel format selection
+
     @Override
     void freeTexture(Context ctx, int id) {
         if (VERBOSE) System.err.println("JoglPipeline.freeTexture()");
@@ -7647,32 +7872,32 @@
         }
     }
 
-	@Override
-	int generateTexID(Context ctx) {
-		if (VERBOSE) System.err.println("JoglPipeline.generateTexID()");
-
-		GL gl = context(ctx).getGL();
-		int[] tmp = new int[] { -1 };
-		gl.glGenTextures(1, tmp, 0);
+    @Override
+    int generateTexID(Context ctx) {
+        if (VERBOSE) System.err.println("JoglPipeline.generateTexID()");
 
-		if (tmp[0] < 1)
-			return -1;
+        GL gl = context(ctx).getGL();
+        int[] tmp = new int[]{-1};
+        gl.glGenTextures(1, tmp, 0);
 
-		return tmp[0];
-	}
+        if (tmp[0] < 1)
+            return -1;
+
+        return tmp[0];
+    }
 
     @Override
     void texturemapping(Context ctx,
-            int px, int py,
-            int minX, int minY, int maxX, int maxY,
-            int texWidth, int texHeight,
-            int rasWidth,
-            int format, int objectId,
-            byte[] imageYdown,
-            int winWidth, int winHeight) {
+                        int px, int py,
+                        int minX, int minY, int maxX, int maxY,
+                        int texWidth, int texHeight,
+                        int rasWidth,
+                        int format, int objectId,
+                        byte[] imageYdown,
+                        int winWidth, int winHeight) {
         if (VERBOSE) System.err.println("JoglPipeline.texturemapping()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         int glType = GL.GL_RGBA;
 
@@ -7696,11 +7921,11 @@
         gl.glEnable(GL.GL_BLEND);
         gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);
 
-		gl.glEnable(GL.GL_TEXTURE_2D);
-		gl.glPushAttrib(GL2.GL_TRANSFORM_BIT);
-		gl.glMatrixMode(GL.GL_TEXTURE);
-		gl.glLoadIdentity();
-		gl.glPopAttrib();
+        gl.glEnable(GL.GL_TEXTURE_2D);
+        gl.glPushAttrib(GL2.GL_TRANSFORM_BIT);
+        gl.glMatrixMode(GL.GL_TEXTURE);
+        gl.glLoadIdentity();
+        gl.glPopAttrib();
 
         // loaded identity modelview and projection matrix
         gl.glMatrixMode(GL2.GL_PROJECTION);
@@ -7734,24 +7959,28 @@
         gl.glPixelStorei(GL2.GL_UNPACK_SKIP_PIXELS, 0);
         gl.glPixelStorei(GL2.GL_UNPACK_SKIP_ROWS, 0);
 
-        float texMinU = (float) minX/ (float) texWidth;
-        float texMinV = (float) minY/ (float) texHeight;
-        float texMaxU = (float) maxX/ (float) texWidth;
-        float texMaxV = (float) maxY/ (float) texHeight;
-        float halfWidth = (float)winWidth/2.0f;
-        float halfHeight = (float)winHeight/2.0f;
-
-        float mapMinX = (float) (((px + minX)- halfWidth)/halfWidth);
-        float mapMinY = (float) ((halfHeight - (py + maxY))/halfHeight);
-        float mapMaxX = (float) ((px + maxX - halfWidth)/halfWidth);
-        float mapMaxY = (float) ((halfHeight - (py + minY))/halfHeight);
+        float texMinU = (float) minX / (float) texWidth;
+        float texMinV = (float) minY / (float) texHeight;
+        float texMaxU = (float) maxX / (float) texWidth;
+        float texMaxV = (float) maxY / (float) texHeight;
+        float halfWidth = (float) winWidth / 2.0f;
+        float halfHeight = (float) winHeight / 2.0f;
+
+        float mapMinX = (float) (((px + minX) - halfWidth) / halfWidth);
+        float mapMinY = (float) ((halfHeight - (py + maxY)) / halfHeight);
+        float mapMaxX = (float) ((px + maxX - halfWidth) / halfWidth);
+        float mapMaxY = (float) ((halfHeight - (py + minY)) / halfHeight);
 
         gl.glBegin(GL2.GL_QUADS);
 
-        gl.glTexCoord2f(texMinU, texMaxV); gl.glVertex2f(mapMinX,mapMinY);
-        gl.glTexCoord2f(texMaxU, texMaxV); gl.glVertex2f(mapMaxX,mapMinY);
-        gl.glTexCoord2f(texMaxU, texMinV); gl.glVertex2f(mapMaxX,mapMaxY);
-        gl.glTexCoord2f(texMinU, texMinV); gl.glVertex2f(mapMinX,mapMaxY);
+        gl.glTexCoord2f(texMinU, texMaxV);
+        gl.glVertex2f(mapMinX, mapMinY);
+        gl.glTexCoord2f(texMaxU, texMaxV);
+        gl.glVertex2f(mapMaxX, mapMinY);
+        gl.glTexCoord2f(texMaxU, texMinV);
+        gl.glVertex2f(mapMaxX, mapMaxY);
+        gl.glTexCoord2f(texMinU, texMinV);
+        gl.glVertex2f(mapMinX, mapMaxY);
         gl.glEnd();
 
         // Java 3D always clears the Z-buffer
@@ -7762,10 +7991,10 @@
 
     @Override
     boolean initTexturemapping(Context ctx, int texWidth,
-            int texHeight, int objectId) {
+                               int texHeight, int objectId) {
         if (VERBOSE) System.err.println("JoglPipeline.initTexturemapping()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         int glType = (gl.isExtensionAvailable("GL_EXT_abgr") ? GL2.GL_ABGR_EXT : GL.GL_RGBA);
 
@@ -7789,7 +8018,6 @@
         return true;
     }
 
-
     // Set internal render mode to one of FIELD_ALL, FIELD_LEFT or
     // FIELD_RIGHT.  Note that it is up to the caller to ensure that
     // stereo is available before setting the mode to FIELD_LEFT or
@@ -7799,7 +8027,7 @@
     void setRenderMode(Context ctx, int mode, boolean doubleBuffer) {
         if (VERBOSE) System.err.println("JoglPipeline.setRenderMode()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         int drawBuf = 0;
         if (doubleBuffer) {
             drawBuf = GL.GL_BACK;
@@ -7845,8 +8073,11 @@
         }
     }
 
-    //----------------------------------------------------------------------
-    // Helper private functions for Canvas3D
+
+    // ---------------------------------------------------------------------
+
+    //
+    // DrawingSurfaceObject methods
     //
 
     private boolean getPropertiesFromCurrentContext(JoglContext ctx, GL2 gl) {
@@ -7887,34 +8118,19 @@
                     // Avoid possibly confusing situations by requiring
                     // major version to match
                     if (altMajor == major &&
-                            altMinor >  minor) {
+                            altMinor > minor) {
                         minor = altMinor;
                     }
                 }
             }
         }
-        return new int[] { major, minor };
+        return new int[]{major, minor};
     }
 
-// FIXME: GL_SGI_texture_color_table
-//    private int getTextureColorTableSize(GL gl) {
-//        if (!gl.isExtensionAvailable("GL_ARB_imaging")) {
-//            return 0;
-//        }
-//
-//        gl.glColorTable(GL.GL_PROXY_TEXTURE_COLOR_TABLE_SGI, GL.GL_RGBA, 256, GL.GL_RGB,
-//                GL2.GL_INT, null);
-//        int[] tmp = new int[1];
-//        gl.glGetColorTableParameteriv(GL.GL_PROXY_TEXTURE_COLOR_TABLE_SGI,
-//                GL2.GL_COLOR_TABLE_WIDTH, tmp, 0);
-//        return tmp[0];
-//    }
-
-
     private void checkTextureExtensions(Canvas3D cv,
-            JoglContext ctx,
-            GL gl,
-            boolean gl13) {
+                                        JoglContext ctx,
+                                        GL gl,
+                                        boolean gl13) {
         if (gl13) {
             cv.textureExtendedFeatures |= Canvas3D.TEXTURE_MULTI_TEXTURE;
             cv.multiTexAccelerated = true;
@@ -7982,7 +8198,7 @@
         if (gl.isExtensionAvailable("GL_EXT_texture_filter_anisotropic")) {
             cv.textureExtendedFeatures |= Canvas3D.TEXTURE_ANISOTROPIC_FILTER;
             float[] tmp = new float[1];
-            gl.glGetFloatv(GL. GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, tmp, 0);
+            gl.glGetFloatv(GL.GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, tmp, 0);
             cv.anisotropicDegreeMax = tmp[0];
         }
 
@@ -8002,18 +8218,21 @@
 
     }
 
+    //----------------------------------------------------------------------
+    // Context-related routines
+    //
 
     private void checkGLSLShaderExtensions(Canvas3D cv,
-            JoglContext ctx,
-            GL gl,
-            boolean hasgl13) {
-
-		// Force shaders to be disabled, since no multitexture support
-		if (!hasgl13)
-			return;
+                                           JoglContext ctx,
+                                           GL gl,
+                                           boolean hasgl13) {
+
+        // Force shaders to be disabled, since no multitexture support
+        if (!hasgl13)
+            return;
 
         if (gl.isExtensionAvailable("GL_ARB_shader_objects") &&
-            gl.isExtensionAvailable("GL_ARB_shading_language_100")) {
+                gl.isExtensionAvailable("GL_ARB_shading_language_100")) {
 
             // FIXME: this isn't complete and would need to set up the
             // JoglContext for dispatch of various routines such as those
@@ -8063,11 +8282,11 @@
         cv.shadingLanguageGLSL = false;
 
         // Now make queries and set up these fields
-        String glVersion  = gl.glGetString(GL.GL_VERSION);
-        String glVendor   = gl.glGetString(GL.GL_VENDOR);
+        String glVersion = gl.glGetString(GL.GL_VERSION);
+        String glVendor = gl.glGetString(GL.GL_VENDOR);
         String glRenderer = gl.glGetString(GL.GL_RENDERER);
-        cv.nativeGraphicsVersion  = glVersion;
-        cv.nativeGraphicsVendor   = glVendor;
+        cv.nativeGraphicsVersion = glVersion;
+        cv.nativeGraphicsVendor = glVendor;
         cv.nativeGraphicsRenderer = glRenderer;
 
         // find out the version, major and minor version number
@@ -8089,7 +8308,7 @@
         if (major < 1 || (major == 1 && minor < 2)) {
             throw new IllegalRenderingStateException(
                     "Java 3D ERROR : OpenGL 1.2 or better is required (GL_VERSION=" +
-                    major + "." + minor + ")");
+                            major + "." + minor + ")");
         }
 
         boolean gl20 = false;
@@ -8193,12 +8412,12 @@
         }
     }
 
-  /*
-   * Function to disable most rendering attributes when doing a 2D
-   * clear, image copy, or image composite operation. Note that the
-   * caller must save/restore the attributes with
-   * pushAttrib(GL_ENABLE_BIT|...) and popAttrib()
-   */
+    /*
+     * Function to disable most rendering attributes when doing a 2D
+     * clear, image copy, or image composite operation. Note that the
+     * caller must save/restore the attributes with
+     * pushAttrib(GL_ENABLE_BIT|...) and popAttrib()
+     */
     private void disableAttribFor2D(GL gl) {
         gl.glDisable(GL2.GL_ALPHA_TEST);
         gl.glDisable(GL.GL_BLEND);
